//
//  ZKMRNLightController.h
//  Zirkonium
//
//  Created by C. Ramakrishnan on 17.10.07.
//  Copyright 2007 Illposed Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>


#define IP_MTU_SIZE 1536
@class ZKMRNZirkoniumSystem;
@interface ZKMRNLightController : NSObject {
	ZKMRNZirkoniumSystem*	_zirkoniumSystem;
	BOOL					_isSendingLighting;
	unsigned				_numberOfLights;

	NSTimer*				_lightTimer;
	NSTimeInterval			_lightTimerInterval;

	//  Network State
	CFSocketRef				_socket;
	CFDataRef				_lightServerAddressData;
	CFMutableDataRef		_messageData;
	CFIndex					_messageDataSize;
	char					_messageBuffer[IP_MTU_SIZE];
	
	//  db / rgb table
	float					_dbLightTable[64*3];
	unsigned				_dbLightTableSize;
	float					_lightGain;
}

//  Initialize
- (id)initWithZirkoniumSystem:(ZKMRNZirkoniumSystem *)zirkoniumSystem;

//  Accessors
- (BOOL)isSendingLighting;
- (void)setSendingLighting:(BOOL)isSendingLighting;

- (NSTimeInterval)lightTimerInterval;
- (void)setLightTimerInterval:(NSTimeInterval)lightTimerInterval;

- (float *)dbLightTable;
- (unsigned)dbLightTableSize;

- (NSData *)dbLightTableData;
- (void)setDBLightTableData:(NSData *)dbLightTableData;

- (float)lightGain;
- (void)setLightGain:(float)lightGain;

//  Actions
- (void)speakerSetupChanged;
- (void)setDBLightTableToDefault;

@end
